#include <cstdio>
#include <vector>

#define MAXN 10005
#define X first
#define Y second
#define mp make_pair
#define pb push_back

using namespace std;

typedef pair<int,int> pii;

void Read();

int N, M, from, key, to;
vector<int> e[MAXN], type[MAXN];
pair< pii, int> queue[2*MAXN]; //2*MAXN because every node can be reached twice ( with or without the key )

void BFS () {
	int i, j, nqueue = 0;
	int visited[MAXN][2];
	int v, k, dist, neib, kneib;

	//queue[i].X.X = node
	//queue[i].X.Y = key
	//queue[i].Y = distance
	queue[ ++nqueue ] = mp ( mp ( from, from==key ), 0 );
	for ( i=1; i<=nqueue; ++i ) {
		v = queue[i].X.X;
		k = queue[i].X.Y; 
		dist = queue[i].Y;

		if ( v==to ) {
			printf ("%d\n", dist);
			return;
		}

		for ( j=0; j<e[v].size(); ++j ) {
			if ( type[v][j] == 1 && k==0 ) {
				continue; //you don't have the key
			}

			neib = e[v][j];
			kneib = ( k | neib == key ); //you either have the key from before, or you are at the node with the key

			if ( !visited[ neib ][kneib] ) {
				visited[neib][kneib] = true;
				queue[ ++nqueue ] = mp ( mp ( neib, kneib ), dist+1 );
			}
		}
	}

	printf ("-1\n");
}

int main ( void ) {
	freopen ("jigsaw.in","r",stdin);
	freopen ("jigsaw.out","w",stdout);
	Read();
	BFS();
}

void Read() {
	int i, a, b, edge_type;

	scanf ("%d %d %d %d %d", &N, &M, &from, &to, &key);
	for ( i=1; i<=M; ++i ) {
		scanf ("%d %d %d", &a, &b, &edge_type);
		e[a].pb (b);
		type[a].pb ( edge_type );
		e[b].pb (a);
		type[b].pb ( edge_type );
	}
}
